/*
	classe des comptes
*/

#ifndef _COMPTE_H_
#define _COMPTE_H_

#include "montant.h"
#include "date.h"

#define LG_NUMERO_COMPTE	12

class TCompte {

private:
	char 	Numero[LG_NUMERO_COMPTE+1];		// Numro de compte
	int 	Suivant;
	TMontant Solde_Reel, Solde_Reel_Init;
	TMontant Solde_Banque, Solde_Banque_Init;
	TDate	Date_Creation; 						// Date de creation du compte
	TDate	Date_Operation;                  // Date de derniere ouverture




};

#define LG_NOM_FICHIER 31
#define LG_LIBELLE 88


#define max(a,b)        (((a) > (b)) ? (a) : (b))
#define min(a,b)        (((a) < (b)) ? (a) : (b))


typedef struct ctxt {
	int suivant;
	int rang_max;
	int nb_code;
	char nom_fichier[LG_NOM_FICHIER];
	char nom_fich_code[LG_NOM_FICHIER];
	TMontant solde_banque;
	TMontant solde_reel;
	int mois_sys;
	int jour_sys;
	int annee_sys;
	int again;
	long num_chq;
} ctxt, *pctxt;

typedef struct {
	TDate Date_Op;
	union {
		long numero_chq;
		unsigned char type;
	} mode_paiement;
	char libelle[LG_LIBELLE];
	TMontant montant;
	unsigned int code;
	TDate Date_Marquage;
} Fiche, *PFiche;


#endif