/*
	Classe pour les montant
*/

#ifndef _MONTANT_H_
#include <iostream.h>

class TMontant {
private:
	long Francs;
	int Centimes;
	char Valid;

	void corrige_valeur ();

public:
	TMontant (long francs=0, int centimes=0);
//	TMontant (double d);
	TMontant (char *Chaine, int Long_Champ);

	TMontant operator + (const TMontant &M2);
	TMontant operator - (const TMontant &M2);
	TMontant& operator += (const TMontant &M2);
	TMontant& operator -= (const TMontant &M2);
	TMontant& operator *= (const TMontant &M );

	TMontant operator - ();

	int operator <  ( const TMontant & M ) const;
	int operator >  ( const TMontant & M ) const;
	int operator <=  ( const TMontant & M ) const;
	int operator >=  ( const TMontant & M ) const;
	int operator ==  ( const TMontant & M ) const;

	int IsValid () { return Valid; }

	friend TMontant abs (TMontant &M);

	friend ostream & operator << (ostream &out, TMontant &M);
#ifdef pasbon
	friend istream & operator >> (istream &in, TMontant &M);
#endif
};

#define LONG_MAX_MONTANT	(1+10+1+2)	// -2147483647.99\0 
#endif
